%global pkg_name HTTP

%bcond_without doc
%bcond_without prof

# ghc does not emit debug information
%global debug_package %{nil}

Name:           ghc-%{pkg_name}
# part of haskell-platform-2009.2.0.2
Version:        4000.0.6
Release:        6%{?dist}
Summary:        Haskell HTTP client library

Group:          Development/Libraries
License:        BSD
URL:            http://projects.haskell.org/http/
Source0:        http://hackage.haskell.org/packages/archive/%{pkg_name}/%{version}/%{pkg_name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# fedora ghc archs:
ExclusiveArch:  %{ix86} x86_64 ppc alpha
BuildRequires:  ghc, ghc-rpm-macros
BuildRequires:  ghc-network-devel
%if %{with doc}
BuildRequires:  ghc-doc
BuildRequires:  ghc-network-doc
%endif
%if %{with prof}
BuildRequires:  ghc-prof
BuildRequires:  ghc-network-prof
%endif

%description
A Haskell library for client-side HTTP.


%package devel
Summary:        Haskell %{pkg_name} library
Group:          Development/Libraries
Provides:       ghc-%{pkg_name} = %{version}-%{release}
Requires:       ghc = %{ghc_version}
Requires(post): ghc = %{ghc_version}
Requires(preun): ghc = %{ghc_version}
Requires:       ghc-network-devel = %ghc_pkg_ver network

%description devel
A Haskell library for client-side HTTP.

This package contains the development files for %{name}
built for ghc-%{ghc_version}.


%if %{with doc}
%package doc
Summary:        Documentation for %{name}
Group:          Development/Libraries
Requires:       ghc-doc = %{ghc_version}
Requires(post): ghc-doc = %{ghc_version}
Requires(postun): ghc-doc = %{ghc_version}
Requires:       ghc-network-doc = %ghc_pkg_ver network

%description doc
This package contains development documentation files for the %{name} library.
%endif


%if %{with prof}
%package prof
Summary:        Profiling libraries for %{name}
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}-%{release}
Requires:       ghc-prof = %{ghc_version}
Requires:       ghc-network-prof = %ghc_pkg_ver network

%description prof
This package contains profiling libraries for %{name}
built for ghc-%{ghc_version}.
%endif


%prep
%setup -q -n %{pkg_name}-%{version}


%build
%cabal_configure --ghc %{?with_prof:-p}
%cabal build
%if %{with doc}
%cabal haddock
%endif
%ghc_gen_scripts


%install
rm -rf $RPM_BUILD_ROOT
%cabal_install
%ghc_install_scripts
%ghc_gen_filelists %{name}


%clean
rm -rf $RPM_BUILD_ROOT


%post devel
%ghc_register_pkg


%if %{with doc}
%post doc
%ghc_reindex_haddock
%endif


%preun devel
if [ "$1" -eq 0 ] ; then
  %ghc_unregister_pkg
fi


%if %{with doc}
%postun doc
if [ "$1" -eq 0 ] ; then
  %ghc_reindex_haddock
fi
%endif


%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}


%if %{with doc}
%files doc -f %{name}-doc.files
%defattr(-,root,root,-)
%endif


%if %{with prof}
%files prof -f %{name}-prof.files
%defattr(-,root,root,-)
%endif


%changelog
* Mon Nov 16 2009 Jens Petersen <petersen@redhat.com> - 4000.0.6-6
- use %%ghc_pkg_ver for requires

* Mon Sep 28 2009 Jens Petersen <petersen@redhat.com> - 4000.0.6-5
- buildrequire the new ghc-network library

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4000.0.6-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat May 30 2009 Jens Petersen <petersen@redhat.com> - 4000.0.6-3
- ppc workaround no longer needed with ghc-6.10.3
- provide ghc-HTTP (cabal2spec-0.17)

* Wed May 13 2009 Jens Petersen <petersen@redhat.com> - 4000.0.6-2
- rebuild with ghc-rpm-macros and ghc-6.10.3 (cabal2spec-0.16)

* Sat Apr 25 2009 Jens Petersen <petersen@redhat.com> - 4000.0.6-1
- update to 4000.0.6
- sync with cabal2spec-0.14
- compile Setup on ppc to workaround runghc failure

* Fri Feb 27 2009 Jens Petersen <petersen@redhat.com> - 4000.0.4-3
- update url
- update to cabal2spec-0.12:
- use ix86 in archs and add alpha
- add devel subpackage
- use global rather than define
- devel owns docdir

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4000.0.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Feb 23 2009 Jens Petersen <petersen@redhat.com> - 4000.0.4-1
- update to 4000.0.4

* Fri Feb 13 2009 Jens Petersen <petersen@redhat.com> - 3001.1.5-2
- sync with latest template and add a doc subpackage

* Tue Dec 23 2008 Jens Petersen <petersen@redhat.com> - 3001.1.5-1
- update to 3001.1.5
- use bcond for doc and prof
- minor tweaks for latest packaging guidelines

* Fri Nov 28 2008 Jens Petersen <petersen@redhat.com> - 3001.1.4-4
- drop LICENSE from -prof subpackage

* Tue Nov 25 2008 Jens Petersen <petersen@redhat.com> - 3001.1.4-3
- add build_doc and build_prof switches
- provide -devel
- drop redundant pre script
- only regenerate doc index in postun if uninstalling

* Mon Nov 10 2008 Jens Petersen <petersen@redhat.com> - 3001.1.4-2
- only build on ghc archs
- version install script requires

* Mon Nov 10 2008 Jens Petersen <petersen@redhat.com> - 3001.1.4-1
- initial packaging for fedora
